<template>
  <div id="loading-screen" style="
      position: absolute;
      width: 100%;
      height: 100%;
      background: white;
      z-index: 1000;
      display: flex;
      align-items: center;
      justify-content: center;
    ">
    <img src="images/logo_233x233.png" alt="Loading..." id="loading-logo" />
  </div>
  <div id="phaser-container"></div>
</template>

<script lang="ts">
import 'phaser';
// import 'phaser3-rex-plugins/templates/ui/ui-plugin';
// import 'phaser3-rex-plugins/templates/ui/ui-components';
import CreateMoreScrollablePanels from '../../kanbans/CreateScrollablePanel';
import { useKanvasoStore } from '../../../stores/kanvaso';
import { mapActions, mapState } from 'pinia';
// import PreloadScene from './PreloadScene';
// import BootScene from './BootScene';
import { KanvasojKanvaso, TreeNode } from '../../../types/stores/kanvaso';
import CreateToolbar from '../../toolbar/CreateToolbar';
import { watch, computed } from 'vue';
import { Router } from 'vue-router';
import UIPlugin from 'phaser3-rex-plugins/templates/ui/ui-plugin';
import CreateMainMenu from '../../main-menu/MainMenu';
import debugUpdater from 'src/apps/utils/debug/debugUpdater';

declare const window: {
  router: Router;
} & Window;

class EndlessCanvas extends Phaser.Scene {

  private isDragging: boolean;
  private isSpaceDown: boolean; // Добавлено новое свойство для отслеживания состояния клавиши пробела
  private dragStartPoint: { x: number; y: number; };

  rexUI: UIPlugin;
  registry: Phaser.Data.DataManager;
  toolbarWidth: number;
  store: any;
  router: Router;
  objectFields: string[];
  private uiCamera: Phaser.Cameras.Scene2D.Camera;
  isDark: boolean;

  debugTable: Phaser.GameObjects.Text;

  constructor() {
    super({
      key: 'endless-canvas',
    });
    this.store = useKanvasoStore();
    this.router = window.router;
    this.objectFields = [
      'name',
      'isPublished',
      'isDeleted',
      'description',
      'id',
      'type',
      'typeId',
      'parentUuid',
      'hasParent',
    ];
    this.toolbarWidth = 50;
    this.isDark = false;
    this.isDragging = false;
    this.dragStartPoint = { x: 0, y: 0 };

  }

  preload() {
    this.load.scenePlugin(
      'rexuiplugin',
      'rexuiplugin.min.js',
      'rexUI',
      'rexUI',
    );
    this.load.image('icon', 'phaser/stretching_icon.png');
    this.load.image('logo', 'phaser/logo_202x200.png');
    //заполняем registry объектами холста
    this.store.getMap.forEach((element) => {
      this.registry.set(element.uuid, element);
    });
    //организуем слежение за getMap и в случае его изменения выясняем что изменилось и обновляем данные в registry
    const map = computed(() => this.store.getMap);
    watch(map, (newData, oldData) => {
      newData.forEach((element) => {
        const uuid = element.uuid;
        const oldElement = oldData.filter((el) => el.uuid === uuid)[0];
        this.objectFields.forEach((field) => {
          if (oldElement && element && element[field] !== oldElement[field]) {
            this.registry.set(uuid, element);
          }
        });
      });
      //TODO: На данный момент таким образом можем реализовать только обновление существующих объектов. В случае добавления и удаления нужно дорабатывать метод или применять другие подходы. Например полный рестарт сцены (это очень нехорошо :))
      // Добавляем обработку добавления новых элементов
      newData.forEach((element) => {
        if (!oldData.some((el) => el.uuid === element.uuid)) {
          this.registry.set(element.uuid, element);
        }
      });
      // Добавляем обработку удаления элементов
      oldData.forEach((element) => {
        if (!newData.some((el) => el.uuid === element.uuid)) {
          this.registry.remove(element.uuid);
        }
      });
      //Как обновлять реестр понятно. Не совсем понятно пока как убирать добавлять внутриигровые объекты
    });
  }

  create(): void {


    this.input.mouse.disableContextMenu(); // Отключаем контекстное меню правой кнопки мыши
    const scene = this;
    const buttonArray = [
      {
        image: 'logo',
        callback: function () {
          scene.router.push('/projects');
        }
      },
      // {
      //   image: 'universo',
      //   callback: function () { }
      // },
    ];
    const toolbarButtons = [

      {
        image: this.isDark ? 'toolbar_1b' : 'toolbar_1c',
        imageHover: 'toolbar_1a',
        callback: function () {
          // scene.router.push('/projects');
        }
      },
      {
        image: this.isDark ? 'toolbar_2b' : 'toolbar_2c',
        imageHover: 'toolbar_2a',
        callback: function () {
          // scene.router.push('/projects');
        }
      },
      {
        image: this.isDark ? 'toolbar_3b' : 'toolbar_3c',
        imageHover: 'toolbar_3a',
        callback: function () {
          // scene.router.push('/projects');
        }
      },
      {
        image: this.isDark ? 'toolbar_4b' : 'toolbar_4c',
        imageHover: 'toolbar_4a',
        callback: function () {
          // scene.router.push('/projects');
        }
      },



    ];
    //@ts-ignore

    // const back = this.add
    //   .text(0, 0, '<<', {
    //     fontSize: '24px',
    //     backgroundColor: '#000',
    //     color: '#fff',
    //   })
    //   .setDepth(20);
    // back.setInteractive();
    // back.on('pointerdown', () => {
    //   this.router.push('/projects');
    // });
    scene.cameras.main.setBackgroundColor('#abcdef');

    // Скрываем экран загрузки здесь, потому что на этом этапе preload уже завершен
    document.getElementById('loading-screen').style.display = 'none';
    let parent = scene.sys.game.canvas.parentElement;
    let parentWidth = parent.offsetWidth;
    let parentHeight = parent.offsetHeight;
    const numberOfPanels = scene.store.getTree.length;
    let panelWidth = parentWidth - scene.toolbarWidth;
    let panelHeight = parentHeight / numberOfPanels;

    // Создаем черный квадрат в центре сцены для проверки функционалов
    const squareSize = 100;
    const square = this.add.graphics({ fillStyle: { color: 0x000000 } });
    square.fillRect(
      this.cameras.main.centerX - squareSize / 2,
      this.cameras.main.centerY - squareSize / 2,
      squareSize,
      squareSize
    );

    let topPanelsArr = CreateMoreScrollablePanels(
      //@ts-ignore
      scene,
      scene.store.getTree,
      { h: panelHeight, w: panelWidth },
    );
    for (let i = 0; i < topPanelsArr.length; i++) {
      topPanelsArr[i]
        .setPosition(
          parentWidth / 2 + scene.toolbarWidth / 2,
          panelHeight / 2 + i * panelHeight,
        )
        .layout();
    }

    // .drawBounds(this.add.graphics(), 0xff0000)}

    scene.registry.events.on(
      'changedata',
      (parent, key, data, previousData) => { },
    );

    // Обработчик событий клавиатуры для клавиши пробела
    this.input.keyboard.on('keydown-SPACE', () => {
      this.isSpaceDown = true; // Клавиша пробела зажата
      this.input.setDefaultCursor('grab'); // Меняем курсор на "Рука"
    });

    this.input.keyboard.on('keyup-SPACE', () => {
      this.isSpaceDown = false; // Клавиша пробела отпущена
      this.input.setDefaultCursor('default'); // Возвращаем стандартный курсор
      this.isDragging = false; // Отключаем перетаскивание
    });

    // Включаем интерактивность сцены
    this.input.on('pointerdown', (pointer) => {
      if (!this.isSpaceDown && pointer.button !== 2) return; // Изменено условие для проверки правой кнопки мыши
      this.dragStartPoint = { x: pointer.x, y: pointer.y };
      this.isDragging = true;
      this.input.setDefaultCursor('grab');
    });


    this.input.on('pointermove', (pointer) => {
      if (!this.isDragging) return;
      const dragX = pointer.x - this.dragStartPoint.x;
      const dragY = pointer.y - this.dragStartPoint.y;
      this.cameras.main.scrollX -= dragX;
      this.cameras.main.scrollY -= dragY;
      this.dragStartPoint = { x: pointer.x, y: pointer.y };
    });

    this.input.on('pointerup', () => {
      this.isDragging = false;
      this.input.setDefaultCursor('default'); // Возвращаем стандартный курсор
    });

    //перемещение холста при использовании тачпада или колёсиком мыши
    this.input.on('wheel', (pointer, gameObjects, deltaX, deltaY, deltaZ) => {
      const sensibility = 0.3;
      this.cameras.main.scrollX -= deltaX * sensibility;
      this.cameras.main.scrollY -= deltaY * sensibility;
    });




    // Создаем отдельную камеру для UI, которая не будет двигаться
    this.uiCamera = this.cameras.add(0, 0, this.cameras.main.width, this.game.scale.height); // 150 - это ширина Toolbar
    this.uiCamera.setScroll(0, 0); // Фиксируем положение камеры для UI
    this.uiCamera.ignore(this.children.list); // Игнорируем все объекты сцены для этой камеры
    //@ts-ignore
    const mainMenu = CreateMainMenu(scene, buttonArray);//toolbar находится здесь потому что он должен создаваться после инициализации UI камеры
    //@ts-ignore
    const toolbar = CreateToolbar(scene, toolbarButtons);

    this.cameras.main.ignore(mainMenu);
    this.cameras.main.ignore(toolbar);

  }
  update(time: number, delta: number): void {

  }
}







const config: Phaser.Types.Core.GameConfig = {
  type: Phaser.AUTO,
  parent: 'phaser-container',
  width: window.innerWidth,
  height: window.innerHeight,
  input: { touch: true },
  scale: {
    mode: Phaser.Scale.FIT,
    autoCenter: Phaser.Scale.CENTER_BOTH,
  },
  scene: EndlessCanvas,
  plugins: {
    // scene: [
    //   {
    //     key: 'rexUI',
    //     plugin: RexPlugins,
    //     mapping: 'rexUI',
    //   },
    //   // ...
    // ],
  },
};

export default {
  name: 'EndlessCanvas',
  data() {
    return {
      wsSubscribe: null,
      game: null,
    };
  },
  computed: {
    ...mapState(useKanvasoStore, {
      project: 'getKanvaso',
    }),
    currentProject() {
      return this.project ? this.project[0]?.node : null;
    },
    projectUuid() {
      return this.$route?.params?.uuid || '';
    },
  },

  methods: {
    ...mapActions(useKanvasoStore, [
      'onGetKanvasoFull',
      'onEditKanvasoObjekto',
      'onEditKanvaso',
      'onEditKanvasoLigilo',
      'onGetKanvasoObjekto',
      'onKanvasoSubscribe',
    ]),
    resizeHandler() {
      const container = document.getElementById('phaser-container');
      container.style.width = window.innerWidth + 'px';
      container.style.height = window.innerHeight + 'px';
      const canvas = container.querySelector('canvas');
      canvas.style.width = window.innerWidth + 'px';
      canvas.style.height = window.innerHeight + 'px';
      //FIXME: Ещё можно способом ниже изменять напрямую размеры холста, но это не даёт нужного результата. Размер меняется, но по краям появляются чёрные полосы :(
      // //@ts-ignore
      // canvas.attributes.width.value = window.innerWidth;
      // //@ts-ignore
      // canvas.attributes.height.value = window.innerHeight;

      // console.log(
      this.game.scale.resize(window.innerWidth, window.innerHeight);
      // );
    },
  },
  async mounted() {
    interface KanvasojKanvasoResult {
      data?: {
        kanvasojKanvaso?: KanvasojKanvaso;
      };
    }
    document.getElementsByTagName('body')[0].style.overflow = 'hidden';

    await this.onGetKanvasoFull({ uuid: this.projectUuid })
      .then((result: KanvasojKanvasoResult) => {
        if (!result.data.kanvasojKanvaso.edges.length) {
          throw new Error(result.toString());
        }
        this.onKanvasoSubscribe({
          kanvasoj: [this.currentProject.objId],
        }).then((data: any) => {
          this.wsSubscribe = data;
        });
      })
      .catch((err: any) => {
        console.log('error get kanvaso full :>> ', err);
        this.$router.replace({ name: 'projects' });
      });
    await this.onGetKanvasoObjekto({ kanvaso_Uuid: this.projectUuid });

    window.addEventListener('resize', this.resizeHandler);
    window.router = this.$router;
    this.game = new Phaser.Game(config);
    // window.addEventListener('resize', function (event) {
    //   console.log('resize');
    //   game.scale.resize(
    //     window.innerWidth < 600 ? window.innerWidth : window.innerWidth - 205,
    //     window.innerWidth < 600
    //       ? window.innerHeight - 51
    //       : window.innerHeight - 10,
    //   );
    // });
    // setInterval(() => {
    //   game.scale.resize(
    //     window.innerWidth < 600 ? window.innerWidth : window.innerWidth - 205,
    //     window.innerWidth < 600
    //       ? window.innerHeight - 51
    //       : window.innerHeight - 10,
    //   );
    // }, 100);
  },
  beforeUnmount() {
    this.wsSubscribe.unsubscribe();
    document.getElementsByTagName('body')[0].style.overflow = 'auto';
    this.game.destroy();
    delete window.router;
  },
};
</script>
<style>
#phaser-container>canvas {
  margin-top: 0 !important;
}
</style>
